defmodule OutlookWeb.DeeplAccountLive.Index do
  use OutlookWeb, :live_view

  alias Outlook.Translators
  alias Outlook.Translators.DeeplAccount

  @impl true
  def mount(_params, _session, socket) do
    {:ok, assign(socket, :deepl_accounts, list_deepl_accounts())}
  end

  @impl true
  def handle_params(params, _url, socket) do
    {:noreply, apply_action(socket, socket.assigns.live_action, params)}
  end

  defp apply_action(socket, :edit, %{"id" => id}) do
    socket
    |> assign(:page_title, "Edit Deepl account")
    |> assign(:deepl_account, Translators.get_deepl_account!(id))
  end

  defp apply_action(socket, :new, _params) do
    socket
    |> assign(:page_title, "New Deepl account")
    |> assign(:deepl_account, %DeeplAccount{user_id: socket.assigns.current_user})
  end

  defp apply_action(socket, :index, _params) do
    socket
    |> assign(:page_title, "Listing Deepl accounts")
    |> assign(:deepl_account, nil)
  end

  @impl true
  def handle_event("delete", %{"id" => id}, socket) do
    deepl_account = Translators.get_deepl_account!(id)
    {:ok, _} = Translators.delete_deepl_account(deepl_account)

    {:noreply, assign(socket, :deepl_accounts, list_deepl_accounts())}
  end

  defp list_deepl_accounts do
    Translators.list_deepl_accounts()
  end
end
